diff --git a/lib-src/portmixer/src/px_linux_alsa.c b/lib-src/portmixer/src/px_linux_alsa.c
index 2b4e70f..e36bf7d 100644
--- a/lib-src/portmixer/src/px_linux_alsa.c
+++ b/lib-src/portmixer/src/px_linux_alsa.c
@@ -136,12 +136,14 @@ static int open_mixer(PxDev *dev, int card, int playback)
                dev->numselems++;
             }
             else if (snd_mixer_selem_is_enum_capture(elem)) {
-               dev->numselems += snd_mixer_selem_get_enum_items(elem);
+                if (0 < snd_mixer_selem_get_enum_items(elem)) {
+                    dev->numselems += snd_mixer_selem_get_enum_items(elem);
+                }
             }
          }
       }
 
-      dev->selems = calloc(dev->numselems, sizeof(PxSelem));
+      dev->selems = calloc(2*(dev->numselems), sizeof(PxSelem));
       if (dev->selems == NULL) {
          break;
       }
@@ -164,9 +166,13 @@ static int open_mixer(PxDev *dev, int card, int playback)
                         snd_mixer_selem_get_name(elem),
                         snd_mixer_selem_get_index(elem));
       
-               dev->selems[i].elem = elem;
-               dev->selems[i].index = snd_mixer_selem_get_index(elem);
-               dev->selems[i].name = strdup(name);
+               if (i < dev->numselems) {
+                   dev->selems[i].elem = elem;
+                   dev->selems[i].index = snd_mixer_selem_get_index(elem);
+                   dev->selems[i].name = strdup(name);
+               } else {
+                   printf ("broken: i larger than dev->numselems\n");
+               }
                if (!dev->selems[i].name) {
                   break;
                }
